import { FitType, ID, PartialBoolean } from "../types";
import type { ListQueries } from "./list_queries";
export declare const BY_ID_QUERIES: {
    readonly nodes: "nodeById";
    readonly accounts: "accountById";
    readonly burnTransactions: "burnTransactionById";
    readonly cities: "cityById";
    readonly contractBillReports: "contractBillReportById";
    readonly contractResources: "contractResourcesById";
    readonly countries: "countryById";
    readonly entityProofs: "entityProofById";
    readonly farmingPolicies: "farmingPolicyById";
    readonly farms: "farmById";
    readonly historicalBalances: "historicalBalanceById";
    readonly interfaces: "interfacesById";
    readonly locations: "locationById";
    readonly mintTransactions: "mintTransactionById";
    readonly nameContracts: "nameContractById";
    readonly nodeContracts: "nodeContractById";
    readonly nodeResourcesTotals: "nodeResourcesTotalById";
    readonly nruConsumptions: "nruConsumptionById";
    readonly pricingPolicies: "pricingPolicyById";
    readonly publicConfigs: "publicConfigById";
    readonly publicIps: "publicIpById";
    readonly refundTransactions: "refundTransactionById";
    readonly rentContracts: "rentContractById";
    readonly solutionProviders: "solutionProviderById";
    readonly transfers: "transferById";
    readonly twins: "twinById";
    readonly uptimeEvents: "uptimeEventById";
};
export type ByIdQueries = {
    [K in keyof ListQueries as K extends keyof typeof BY_ID_QUERIES ? (typeof BY_ID_QUERIES)[K] : K]: <T extends PartialBoolean<ReturnType<ListQueries[K]> extends Promise<Array<infer Q>> ? Q : unknown>>(id: ID, fields: T) => ReturnType<ListQueries[K]> extends Promise<Array<infer Q>> ? Promise<FitType<T, Q>> : Promise<unknown>;
};
//# sourceMappingURL=by_id_queries.d.ts.map