import { FitType, Int, PartialBoolean } from "../types";
import { ByArray } from "./abstract_client";
import { ListQueries } from "./list_queries";
export declare const CONNECTION_QUERIES: {
    readonly nodes: "nodesConnection";
    readonly accounts: "accountsConnection";
    readonly burnTransactions: "burnTransactionsConnection";
    readonly cities: "citiesConnection";
    readonly contractBillReports: "contractBillReportsConnection";
    readonly contractResources: "contractResourcesConnection";
    readonly countries: "countriesConnection";
    readonly entityProofs: "entityProofsConnection";
    readonly farmingPolicies: "farmingPoliciesConnection";
    readonly farms: "farmsConnection";
    readonly historicalBalances: "historicalBalancesConnection";
    readonly interfaces: "interfacesConnection";
    readonly locations: "locationsConnection";
    readonly mintTransactions: "mintTransactionsConnection";
    readonly nameContracts: "nameContractsConnection";
    readonly nodeContracts: "nodeContractsConnection";
    readonly nodeResourcesTotals: "nodeResourcesTotalsConnection";
    readonly nruConsumptions: "nruConsumptionsConnection";
    readonly pricingPolicies: "pricingPoliciesConnection";
    readonly publicConfigs: "publicConfigsConnection";
    readonly publicIps: "publicIpsConnection";
    readonly refundTransactions: "refundTransactionsConnection";
    readonly rentContracts: "rentContractsConnection";
    readonly solutionProviders: "solutionProvidersConnection";
    readonly transfers: "transfersConnection";
    readonly twins: "twinsConnection";
    readonly uptimeEvents: "uptimeEventsConnection";
};
export declare const CONNECTION_ENTITY_QUERIES: {
    readonly nodesConnection: "Node";
    readonly accountsConnection: "Account";
    readonly burnTransactionsConnection: "BurnTransaction";
    readonly citiesConnection: "City";
    readonly contractBillReportsConnection: "ContractBillReport";
    readonly contractResourcesConnection: "ContractResources";
    readonly countriesConnection: "Country";
    readonly entityProofsConnection: "EntityProof";
    readonly farmingPoliciesConnection: "FarmingPolicy";
    readonly farmsConnection: "Farm";
    readonly historicalBalancesConnection: "HistoricalBalance";
    readonly interfacesConnection: "Interfaces";
    readonly locationsConnection: "Location";
    readonly mintTransactionsConnection: "MintTransaction";
    readonly nameContractsConnection: "NameContract";
    readonly nodeContractsConnection: "NodeContract";
    readonly nodeResourcesTotalsConnection: "NodeResourcesTotal";
    readonly nruConsumptionsConnection: "NruConsumption";
    readonly pricingPoliciesConnection: "PricingPolicy";
    readonly publicConfigsConnection: "PublicConfig";
    readonly publicIpsConnection: "PublicIp";
    readonly refundTransactionsConnection: "RefundTransaction";
    readonly rentContractsConnection: "RentContract";
    readonly solutionProvidersConnection: "SolutionProvider";
    readonly transfersConnection: "Transfer";
    readonly twinsConnection: "Twin";
    readonly uptimeEventsConnection: "UptimeEvent";
};
interface __Connection<T> {
    edges: {
        node: T;
        cursor: string;
    };
    pageInfo: {
        hasNextPage: boolean;
        hasPreviousPage: boolean;
        startCursor: string;
        endCursor: string;
    };
    totalCount: Int;
}
type __ConnectionOptions<O extends string, W> = {
    after?: string;
    first?: Int;
    orderBy: `${O}_${"ASC" | "DESC"}`[];
    where?: W;
};
type G<T> = T extends ByArray<infer O, infer W> ? __ConnectionOptions<O, W> : undefined;
export type ConnectionQueries = {
    [K in keyof ListQueries as K extends keyof typeof CONNECTION_QUERIES ? (typeof CONNECTION_QUERIES)[K] : K]: <T extends PartialBoolean<__Connection<ReturnType<ListQueries[K]> extends Promise<Array<infer Q>> ? Q : unknown>>>(fields: T, options: G<Parameters<ListQueries[K]>[1]>) => Promise<FitType<T, __Connection<ReturnType<ListQueries[K]> extends Promise<Array<infer Q>> ? Q : unknown>>>;
};
export {};
//# sourceMappingURL=connection_queries.d.ts.map